<!DOCTYPE html>
<html lang="en">

<head>
	<title>task 37.60</title>
	<meta charset="UTF-8">
	<meta http-equiv="X-UA-Compatible" content="IE=edge">
	<meta name="viewport" content="width=device-width, initial-scale=1.0">
	<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
	<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css">
	<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/js/bootstrap.min.js"></script>
	<!-- Import style bootstrap cho datatable -->
	<link rel="stylesheet" href="https://cdn.datatables.net/1.13.3/css/dataTables.bootstrap4.min.css">
	<script src="https://cdn.datatables.net/1.13.3/js/jquery.dataTables.min.js"></script>
	<script src="https://cdn.datatables.net/1.13.3/js/dataTables.bootstrap4.min.js"></script>
	<!-- font-awesome -->
	<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.3.0/css/all.min.css">

	<style>
		.icon-cursor {
			cursor: -webkit-grab; cursor: grab;
		}
	</style>

</head>

<body>
	<div class="container-fluid">
		<h1 class="text-center">List and information of information technology courses </h1>
		<div class="row">
			<div class="col mb-4 mt-4">
				<button id="btn-add-user" class="btn btn-success">Add courses </button>
			</div>
		</div>
		<div class="row">
			<div class="col">
				<table id="user-table" class="table table-striped table-hover table-bordered">
					<thead>
						<tr>
							<th>Stt</th>
							<th>ID</th>
							<th>Course Name </th>
							<th>Cover Image</th>
							<th>Ciscount Price</th>
							<th>Price</th>
							<th>Duration</th>
							<th>isPopular</th>
							<th>isTrending</th>
							<th>Level</th>
							<th>Teacher Name</th>
							<th>Teacher photo</th>
							<th>Course Code</th>
							<th>Action</th>

						</tr>
					</thead>
					<tbody>

					</tbody>
				</table>
			</div>
		</div>
		<!-- Delete confirm modal -->
		<div>
			<div class="modal fade" tabindex="-1" id="delete-confirm-modal">
				<div class="modal-dialog">
					<div class="modal-content">
						<div class="modal-header">
							<h5 class="modal-title" id="h5-modal-title">Confirm delete course</h5>
							<button class="close" data-dismiss="modal">&times;</button>
						</div>
						<div class="modal-body">
							<label>Bạn có chắc chắn muốn xóa course này không?</label>
						</div>
						<div class="modal-footer">
							<button class="btn btn-danger" id="btn-confirm-delete-user">Xác nhận</button>
							<button class="btn btn-secondary" data-dismiss="modal">Hủy bỏ </button>
						</div>
					</div>
				</div>
			</div>
		</div>

	</div>
	<!-- Modal courses insert-->
	<div id="user-insert-modal" class="modal fade" tabindex="-1">
		<div class="modal-dialog">
			<div class="modal-content">
				<div class="modal-header">
					<h5 class="modal-title">User Detail Information</h5>
					<button type="button" class="close" data-dismiss="modal">&times;</button>
				</div>
				<!-- Modal body - chứa form dữ liệu -->
				<div class="modal-body">
					<form> <!-- form thiết kế như form bình thường, theo grid model -->


						<div class="row form-group">
							<label class="col-sm-4 col-form-label">Course Name</label>
							<div class="col-sm-8">
								<input class="form-control" id="input-modal-insert-course-name">
							</div>
						</div>

						<div class="row form-group">
							<label class="col-sm-4 col-form-label">Cover Image</label>
							<div class="col-sm-8">
								<input class="form-control" id="input-modal-insert-cover-image">
							</div>
						</div>

						<div class="row form-group">
							<label class="col-sm-4 col-form-label">Price </label>
							<div class="col-sm-8">
								<input class="form-control" id="input-modal-insert-price">
							</div>
						</div>

						<div class="row form-group">
							<label class="col-sm-4 col-form-label">Discount Price</label>
							<div class="col-sm-8">
								<input class="form-control" id="input-modal-insert-ciscount-price">
							</div>
						</div>



						<div class="row form-group">
							<label class="col-sm-4 col-form-label">Duration</label>
							<div class="col-sm-8">
								<input class="form-control" id="input-modal-insert-duration">
							</div>
						</div>



						<div class="row form-group">
							<label class="col-sm-4 col-form-label">isPopular</label>
							<div class="col-sm-8">
								<select class="form-control" name="" id="input-modal-insert-is-popular">
									<option value="true">true</option>
									<option value="false">false</option>
								</select>
							</div>
						</div>

						<div class="row form-group">
							<label class="col-sm-4 col-form-label">isTrending</label>
							<div class="col-sm-8">
								<select class="form-control" name="" id="input-modal-insert-is-trending">
									<option value="true">true</option>
									<option value="false">false</option>
								</select>
							</div>
						</div>

						<div class="row form-group">
							<label class="col-sm-4 col-form-label">Level</label>
							<div class="col-sm-8">
								<!-- <input class="form-control" id="input-modal-insert-Level"> -->
								<select class="form-control" name="" id="input-modal-update-Level">
									<option value="Beginner">Beginner</option>
									<option value="Intermediate">Intermediate</option>
									<option value="Advanced">Advanced</option>
								</select>
							</div>
						</div>

						<div class="row form-group">
							<label class="col-sm-4 col-form-label">Teacher Name</label>
							<div class="col-sm-8">
								<input class="form-control" id="input-modal-insert-teacher-name">
							</div>
						</div>

						<div class="row form-group">
							<label class="col-sm-4 col-form-label">Teacher photo</label>
							<div class="col-sm-8">
								<input class="form-control" id="input-modal-insert-teacher-photo">
							</div>
						</div>

						<div class="row form-group">
							<label class="col-sm-4 col-form-label">Course Code</label>
							<div class="col-sm-8">
								<input class="form-control" id="input-modal-insert-course-code">
							</div>
						</div>

					</form>
				</div>
				<div class="modal-footer">
					<div class="row">
						<button id="btn-modal-insert" class="btn btn-primary mr-3">Insert Course</button>
						<button type="button" id="btn-modal-close" class="btn btn-secondary" data-dismiss="modal">Close</button>
					</div>
				</div>
			</div>
		</div>
	</div>

	<!-- Update voucher modal (sửa user) -->
	<div>
		<div id="update-voucher-modal" class="modal fade" tabindex="-1">
			<div class="modal-dialog">
				<div class="modal-content">
					<div class="modal-header">
						<h5 class="modal-title" id="h5-modal-title">course details </h5>
						<button class="close" data-dismiss="modal">&times;</button>
					</div>
					<div class="modal-body">
						<form class="">

							<div class="row form-group">
								<label class="col-sm-4 col-form-label">Course Name</label>
								<div class="col-sm-8">
									<input class="form-control" id="input-modal-update-course-name">
								</div>
							</div>

							<div class="row form-group">
								<label class="col-sm-4 col-form-label">Cover Image</label>
								<div class="col-sm-8">
									<input class="form-control" id="input-modal-update-cover-image">
								</div>
							</div>

							<div class="row form-group">
								<label class="col-sm-4 col-form-label">Price </label>
								<div class="col-sm-8">
									<input class="form-control" id="input-modal-update-price">
								</div>
							</div>

							<div class="row form-group">
								<label class="col-sm-4 col-form-label">Discount Price</label>
								<div class="col-sm-8">
									<input class="form-control" id="input-modal-update-ciscount-price">
								</div>
							</div>



							<div class="row form-group">
								<label class="col-sm-4 col-form-label">Duration</label>
								<div class="col-sm-8">
									<input class="form-control" id="input-modal-update-duration">
								</div>
							</div>

							<div class="row form-group">
								<label class="col-sm-4 col-form-label">isPopular</label>
								<div class="col-sm-8">
									<select class="form-control" name="" id="input-modal-update-is-popular">
										<option value="true">true</option>
										<option value="false">false</option>
									</select>
								</div>
							</div>

							<div class="row form-group">
								<label class="col-sm-4 col-form-label">isTrending</label>
								<div class="col-sm-8">
									<select class="form-control" name="" id="input-modal-update-is-trending">
										<option value="true">true</option>
										<option value="false">false</option>
									</select>
								</div>
							</div>

							<div class="row form-group">
								<label class="col-sm-4 col-form-label">Level</label>
								<div class="col-sm-8">
									<!-- <input class="form-control" id="input-modal-update-Level"> -->
									<select class="form-control" name="" id="input-modal-update-Level">
										<option value="Beginner">Beginner</option>
										<option value="Intermediate">Intermediate</option>
										<option value="Advanced">Advanced</option>
									</select>
								</div>
							</div>

							<div class="row form-group">
								<label class="col-sm-4 col-form-label">Teacher Name</label>
								<div class="col-sm-8">
									<input class="form-control" id="input-modal-update-teacher-name">
								</div>
							</div>

							<div class="row form-group">
								<label class="col-sm-4 col-form-label">Teacher photo</label>
								<div class="col-sm-8">
									<input class="form-control" id="input-modal-update-teacher-photo">
								</div>
							</div>

							<div class="row form-group">
								<label class="col-sm-4 col-form-label">Course Code</label>
								<div class="col-sm-8">
									<input class="form-control" id="input-modal-update-course-code">
								</div>
							</div>

						</form>
					</div>
					<div class="modal-footer">
						<button class="btn btn-primary" id="btn-modal-update-user">Update course</button>
						<button class="btn btn-secondary" id="btn-update-cancel" data-dismiss="modal">Hủy bỏ</button>

					</div>
				</div>
			</div>
		</div>
	</div>

</body>
<script>
	"use strict"

	/*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
	var gStt = 0;  // thêm coment thực hành Task 44.40 Đẩy dự án Project Course 365 lên Gitlab và tạo nhánh
	var gId = "";
	const gBASE_URL_COURSES = "https://624abe0dfd7e30c51c110ac6.mockapi.io/api/v1/";

	/*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
	$(document).ready(function () {
		onPageLoading();
		// khai báo nút sửa 
		$("#user-table").on("click", ".btn-edits", onSuaClick); // khai báo nút sửa   
		$("#user-table").on("click", ".btn-deletes", onXoaClick); // khai báo nút xóa
		$("#btn-add-user").on("click", onAddUserClick); // khai báo nút thêm user 
		$("#btn-modal-insert").on("click", onInsertCoursesClick);   // nút xác nhận thêm  
		$("#btn-modal-update-user").on("click", onModalUpdateUserClick);  // khao báo chấp nhận update user
		$("#btn-confirm-delete-user").on("click", onConfirmDeleteUserClick);     // khai báo nút xác nhận xóa 
	});
	/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */ // 
	function onPageLoading() {
		"use strict"
		console.log("đã load xong thẻ body ");
		// load data table jquery nhưng chưa truyền dữ liệu 
		khoiTaoDataTable();
		//b1 bỏ qua task44.50 Tạo nhánh 
		//b2 bỏ qua task44.50 Tạo nhánh task44.50 mới từ nhánh develop bằng VSCode
		//b3  call api && //b4 load data in table 
		callApiAllCourses(getInsertRowTable);
	}
	// khai báo sự kiện nút sửa // khai báo sự kiện nút sửa 
	// khai báo sự kiện nút sửa 

	function onSuaClick() {
		console.log("ấn nút sửa ");
		$("#update-voucher-modal").modal("show");  // hiện modal
		var vObject = readObjectRow(this);
		console.log("id là:  " + vObject.id);
		gId = vObject.id;
		// load toàn bộ thông tin người dùng lên modal
		// b1 b2 bỏ qua
		// b3 . gọi api lấy object  
		var vObjectDataUser = null;
		getUserById(vObject.id, function (pamramRes) {
			// b4 xử lý hiển thị  đổ dữ liệu lên modal 
			loadDataInModalUpdateUser(pamramRes);
			console.log("đã gọi sever");

			return;
		});
	}
	// khai báo sự kiện nút xóa user
	function onXoaClick() {
		console.log("ấn nut xóa ");
		var vObject = readObjectRow(this);
		console.log("id là:  " + vObject.id);
		gId = vObject.id; // 
		$("#delete-confirm-modal").modal("show");  // hiện modal xóa 
	}
	// khai báo sự kiện nút thêm user
	function onAddUserClick() {
		console.log("ấn nut add user ");
		$("#user-insert-modal").modal("show");  // hiện modal.
	}
	// khai báo nút insert user (add user);
	function onInsertCoursesClick() {
		console.log("ấn nút insert user ");
		//04 bước xử lý sự kiện có gọi server
		// b1 thu thâpj dữ liệu
		var vObject = readDataModalInsertCourses();
		// b2 validate data
		var vResult = validateDataInsertCourses(vObject);
		// b3 call server
		if (vResult) {
			callServerCreateCourses(vObject, function (pamramRes) {
				console.log("tạo khóa học thành công", pamramRes);
				// b4 hiển thị font end
				alert("Thêm voucher thành công Id của bạn là  " + pamramRes.id);
				callApiAllCourses(getInsertRowTable);
				resertCreateCoursesForm(); // xóa trắng dữ liệu 
				$("#user-insert-modal").modal("hide");  // ẩn modal
				gId = -1; //  .. reset id
			});

		}
		// b4
		console.log(vObject);
	}

	// khai baos nút xác nhận update  sửa user
	function onModalUpdateUserClick() {
		console.log("ấn nut xác nhận update  user ");
		//04 bước xử lý sự kiện có gọi server
		// b1 thu thâpj dữ liệu
		var vObject = readDataInModalUpdateUser();  // đọc dữ liệu trên form modal sửa thông tin người dùng
		console.log(vObject);
		// b2 validate data
		var vResult = validateDataInsertCourses(vObject);
		// b3 call server
		if (vResult) {
			updateCoursesById(vObject, function (pamramRes) {
				// b4 hiển thị font end 
				console.log("update: ", pamramRes);
				alert("thông báo đã cập nhật  courses với id: " + gId + " thành công");
				$("#update-voucher-modal").modal("hide"); //tắt Modal 
				callApiAllCourses(getInsertRowTable); //  load lại bảng danh sách users
				gId = -1; //  .. reset id
			});
		}
	}
	// nút xác nhận xóa user 
	function onConfirmDeleteUserClick() {
		console.log("Xác nhận xóa ");
		// b3 gọi api để xóa user theo iD 
		callApiDeleteUser(function () {
			// xử lý font end 
			alert("thông báo đã xóa courses với Id:  " + gId + " thành công!");
			$("#delete-confirm-modal").modal("hide"); //tắt Modal 
			callApiAllCourses(getInsertRowTable); //  load lại bảng danh sách users 
			gId = -1; //  .. reset id
		});
	}
	/*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
	// ........................ [onPageLoading].......................
	// khởi tạo data table 
	function khoiTaoDataTable() {
		// khai báo mảng chứa các cột 
		const ARR_COLL_TABLE = ["stt", "id", "courseName", "coverImage", "discountPrice", "price", "duration",
			"isPopular", "isTrending", "level", "teacherName", "teacherPhoto", "courseCode", "action"];
		// khai báo các cột 
		const STT = 0;
		const ID = 1;
		const COURSES_NAME = 2;
		const COVER_IMAGE = 3;
		const DISCOUNT_PRICE = 4;
		const PRICE = 5;
		const DURATION = 6;
		const IS_POPULAR = 7;
		const IS_TRENDING = 8;
		const LEVEL = 9;
		const TEACHER_NAME = 10;
		const TEACHER_PHOTO = 11;
		const COURSES_CODE = 12;
		const ACTION = 13;

		/* add JSON data vào DataTable sử dụng add trực tiếp DataTable row */
		$("#user-table").DataTable({
			columns: [
				{ data: ARR_COLL_TABLE[STT] },
				{ data: ARR_COLL_TABLE[ID] },
				{ data: ARR_COLL_TABLE[COURSES_NAME] },
				{ data: ARR_COLL_TABLE[COVER_IMAGE] },
				{ data: ARR_COLL_TABLE[DISCOUNT_PRICE] },
				{ data: ARR_COLL_TABLE[PRICE] },
				{ data: ARR_COLL_TABLE[DURATION] },
				{ data: ARR_COLL_TABLE[IS_POPULAR] },
				{ data: ARR_COLL_TABLE[IS_TRENDING] },
				{ data: ARR_COLL_TABLE[LEVEL] },
				{ data: ARR_COLL_TABLE[TEACHER_NAME] },
				{ data: ARR_COLL_TABLE[TEACHER_PHOTO] },
				{ data: ARR_COLL_TABLE[COURSES_CODE] },
				{ data: ARR_COLL_TABLE[ACTION] },

			],
			columnDefs: [
				{
					targets: STT,   // cột id
					className: "text-center text-primary",
					render: function () {
						gStt++;
						return gStt;
					}
				},
				{
					targets: ID,   // cột id
					className: "text-center text-danger"
				},

				{
					targets: ACTION,
					defaultContent: '<i class="fa-solid fa-gear btn-edits icon-cursor" data-toggle="tooltip" data-placement="top" title="setting"></i>'
						+ '&nbsp;' + '&nbsp;'
						+ '<i class="fa-solid fa-trash-can-arrow-up btn-deletes icon-cursor" data-toggle="tooltip" data-placement="top" title="delete"></i>',
				},
			]
		});
	}
	//  gọi API load all users
	function callApiAllCourses(pramFunction) {
		// khai báo ajax jquery
		$.ajax({
			url: gBASE_URL_COURSES + "/courses",
			type: "GET",
			dataType: "json",
			success: pramFunction,
			//function (paramRes) {
			// 	// khi gọi api call all user thành công 
			// 	//b4 load data in table 
			// 	getInsertRowTable(paramRes);
			// },
			error: function (paramError) {
				console.log("lỗi khi gọi api All user" + paramError.status);
			}
		});
	}
	// hàm thêm từng dòng dữ liệu vào
	function getInsertRowTable(paramRes) {
		var vTable = $("#user-table").DataTable();
		vTable.clear();// xóa trắng tbody trước khi load dữ liệu  
		vTable.rows.add(paramRes);
		vTable.draw();
		gStt = 0;  // làm mới biến số thứ tự 
	}

	// lấy tất cả giá trị của 1 hàng tương ứng với nút bấm trên hàng đó 
	function readObjectRow(paramThis) {
		console.log(paramThis);
		var vRowClick = $(paramThis).closest("tr"); // xác định hàng của nút ấn trên table  nut ấn 
		var vTable = $("#user-table").DataTable();   // tạo biến đến dataTable 
		var vDataRow = vTable.row(vRowClick);  // tìm hàng này trên data table trên data table 
		return vDataRow.data();
	}
	// ........................ [nút insert user in modal].......................
	//04 bước xử lý sự kiện có gọi server
	// b1 thu thâpj dữ liệu và trả về object chứa thông tin người dùng 
	function readDataModalInsertCourses() {
		var vObjectDataCourses = {

			courseCode: "",
			courseName: "",
			price: "",
			discountPrice: "",
			duration: "",
			level: "",
			coverImage: "",
			teacherName: "",
			teacherPhoto: "",
			isPopular: "",
			isTrending: "",

		}
		//gán giá trị cho object 
		vObjectDataCourses.courseCode = $("#input-modal-insert-course-code").val().trim();
		vObjectDataCourses.courseName = $("#input-modal-insert-course-name").val().trim();
		vObjectDataCourses.price = $("#input-modal-insert-price").val().trim();
		vObjectDataCourses.discountPrice = $("#input-modal-insert-ciscount-price").val().trim();
		vObjectDataCourses.duration = $("#input-modal-insert-duration").val().trim();
		vObjectDataCourses.level = $("#input-modal-insert-Level").val();
		vObjectDataCourses.coverImage = $("#input-modal-insert-cover-image").val().trim();
		vObjectDataCourses.teacherName = $("#input-modal-insert-teacher-name").val().trim();
		vObjectDataCourses.teacherPhoto = $("#input-modal-insert-teacher-photo").val().trim();
		vObjectDataCourses.isPopular = $("#input-modal-insert-is-popular").is(":checked");
		vObjectDataCourses.isTrending = $("#input-modal-insert-is-trending").is(":checked");
		// kết thúc hàm và trả về đối tượng đã gán 
		return vObjectDataCourses;
	}
	// b2 validate data
	// kiểm tra xem người dùng có nhập hay k . nếu không nhập thì nhắc nhở người dùng
	//  áp dụng cho cả add và sửa khóa học 
	function validateDataInsertCourses(paramObject) {
		if (paramObject.courseName === "") {
			alert("course name không được để trống ");
			return false;
		}
		if (paramObject.courseName.length < 20) {
			alert("course name phải lớn hơn 20 ký tự ");
			return false;
		}
		if (paramObject.coverImage === "") {
			alert("Cover Image không được để trống ");
			return false;
		}
		if (paramObject.price === "") {
			alert("price không được để trống ");
			return false;
		}
		if (isNaN(paramObject.price) || paramObject.price <= 0) {
			alert("price (Giá niêm yết của khóa học, chưa giảm) Là số nguyên, > 0 ");
			return false;
		}
		if (paramObject.discountPrice === "") {
			alert("Discount  Price không được để trống ");
			return false;
		}
		if (isNaN(paramObject.discountPrice) || paramObject.discountPrice / 1 < 0 || paramObject.discountPrice / 1 > paramObject.price / 1) {
			alert("Discount  Price Là số nguyên, >= 0 và phải <= price ");
			return false;
		}

		if (paramObject.duration === "") {
			alert("duration không được để trống ");
			return false;
		}
		if (paramObject.isPopular === "") {
			alert("isPopular không được để trống ");
			return false;
		}
		if (paramObject.isTrending === "") {
			alert("isTrending không được để trống ");
			return false;
		}
		if (paramObject.level === "") {
			alert("level không được để trống ");
			return false;
		}
		if (paramObject.teacherName === "") {
			alert("teacher Name không được để trống ");
			return false;
		}
		if (paramObject.teacherPhoto === "") {
			alert("Teacher Photo không được để trống ");
			return false;
		}
		if (paramObject.courseCode === "") {
			alert("course code không được để trống ");
			return false;
		}
		if (paramObject.courseCode.length < 10) {
			alert("course code Text, chứa ít nhất 10 ký tự ");
			return false;
		}

		return true;
	}

	// b3 goi server 
	function callServerCreateCourses(paramObject, paramFunciton) {
		$.ajax({
			url: gBASE_URL_COURSES + "/courses",
			type: "POST",
			contentType: "application/json",
			data: JSON.stringify(paramObject),
			// b4 hiển thị font end 
			success: paramFunciton,
			error: function (paramError) {
				console.log("gọi server không thành công ", paramError.status);
			}
		});
	}

	// hàm xóa trắng form create courses  khi đã gọi sever 
	function resertCreateCoursesForm() {

		$("#input-modal-insert-course-code").val("");   // hàm xóa trắng modal thêm khóa học 
		$("#input-modal-insert-course-name").val("");   // hàm xóa trắng modal thêm khóa học 
		$("#input-modal-insert-price").val("");   // hàm xóa trắng modal thêm khóa học 
		$("#input-modal-insert-ciscount-price").val("");   // hàm xóa trắng modal thêm khóa học 
		$("#input-modal-insert-duration").val("");   // hàm xóa trắng modal thêm khóa học 
		$("#input-modal-insert-Level").val("");   // hàm xóa trắng modal thêm khóa học 
		$("#input-modal-insert-cover-image").val("");   // hàm xóa trắng modal thêm khóa học 
		$("#input-modal-insert-teacher-name").val("");   // hàm xóa trắng modal thêm khóa học 
		$("#input-modal-insert-teacher-photo").val("");   // hàm xóa trắng modal thêm khóa học 
		$("#input-modal-insert-is-popular").val("");   // hàm xóa trắng modal thêm khóa học 
		$("#input-modal-insert-is-trending").val("");   // hàm xóa trắng modal thêm khóa học 
	}
	// ......................[ xử lý nút edit . nút sửa ].....................
	// Mẫu gọi API Get User by id
	function getUserById(paramId, paramFunction) {
		$.ajax({
			url: gBASE_URL_COURSES + "/courses/" + paramId,
			type: "GET",
			dataType: "json",
			success: paramFunction,
			error: function (paramError) {
				console.log(paramError.status);
				alert("Hệ thống chưa thể sửa courses do trục trặc kỹ thuật ");
			},
		});
	}
	//load load dữ liệu lên fomr modal update
	function loadDataInModalUpdateUser(paramObject) {

		$("#input-modal-update-course-code").val(paramObject.courseCode);
		$("#input-modal-update-course-name").val(paramObject.courseName);
		$("#input-modal-update-price").val(paramObject.price);
		$("#input-modal-update-ciscount-price").val(paramObject.discountPrice);
		$("#input-modal-update-duration").val(paramObject.duration);
		$("#input-modal-update-Level").val(paramObject.level);
		$("#input-modal-update-cover-image").val(paramObject.coverImage);
		$("#input-modal-update-teacher-name").val(paramObject.teacherName);
		$("#input-modal-update-teacher-photo").val(paramObject.teacherPhoto);
		$("#input-modal-update-is-popular").val(paramObject.isPopular);
		$("#input-modal-update-is-trending").val(paramObject.isTrending);
	}
	// ..................................[Nút update courser (sửa thông tin courser)].............
	//04 bước xử lý sự kiện có gọi server
	// b1 thu thâpj dữ liệu
	function readDataInModalUpdateUser() {
		var vObjectDataCourses = {

			courseCode: "",
			courseName: "",
			price: "",
			discountPrice: "",
			duration: "",
			level: "",
			coverImage: "",
			teacherName: "",
			teacherPhoto: "",
			isPopular: "",
			isTrending: "",

		}
		//gán giá trị cho object 
		vObjectDataCourses.courseCode = $("#input-modal-update-course-code").val().trim();
		vObjectDataCourses.courseName = $("#input-modal-update-course-name").val().trim();
		vObjectDataCourses.price = $("#input-modal-update-price").val().trim();
		vObjectDataCourses.discountPrice = $("#input-modal-update-ciscount-price").val().trim();
		vObjectDataCourses.duration = $("#input-modal-update-duration").val().trim();
		vObjectDataCourses.level = $("#input-modal-update-Level").val();
		vObjectDataCourses.coverImage = $("#input-modal-update-cover-image").val().trim();
		vObjectDataCourses.teacherName = $("#input-modal-update-teacher-name").val().trim();
		vObjectDataCourses.teacherPhoto = $("#input-modal-update-teacher-photo").val().trim();
		vObjectDataCourses.isPopular = $("#input-modal-update-is-popular").is(":checked");
		vObjectDataCourses.isTrending = $("#input-modal-update-is-trending").is(":checked");
		// kết thúc hàm và trả về đối tượng đã gán 
		return vObjectDataCourses;
	}
	// b2 validate data courser update 
	//   validateDataInsertCourses
	// b3 call server   courser
	//  gọi API Update courser by Id
	function updateCoursesById(paramObject, paramFunction) {
		$.ajax({
			url: gBASE_URL_COURSES + "/courses/" + gId,
			type: "PUT",
			contentType: "application/json",
			data: JSON.stringify(paramObject),
			success: paramFunction,
			error: function (paramError) {
				console.log(paramError.status);
				alert("thông báo đã cập nhật courses không thành công");

			}
		});
	}
	// ................... [nút xác nhận xóa User]............
	function callApiDeleteUser(paramFunciton) {
		$.ajax({
			url: gBASE_URL_COURSES + "/courses/" + gId,
			type: "DELETE",
			dataType: "json",
			success: paramFunciton,
			error: function (paramError) {
				console.log(paramError.status);
				alert("Hệ thống chưa thể xóa courses do trục trặc kỹ thuật ");
				$("#delete-confirm-modal").modal("hide"); //tắt Modal 
			},
		});
	}



</script>

</html>